//+------------------------------------------------------------------+
//|                                               burning_meteor.mq5 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#include<Trade\Trade.mqh>


input ulong MagicNumber=10001;
input double Lots=0.1;
input double StopLoss=0;
input double TakeProfit=0;
input int TrailingStop=40;

// Create a  Ctrade instance
CTrade trade;
int pm;
// Get the Ask price
double Ask=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);

// Get the Bid price
double Bid=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   pm=1;
   if(_Digits==5 || _Digits==3)
      pm=10;
   trade.SetExpertMagicNumber(MagicNumber);

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
void OnTick()
  {
  
   double SL,TP;
   Trailing();
   if(ProfitSymbol()<-400)Reverse();

// create an Array for several prices
   double myMovingAverageArray5[],myMovingAverageArray21[];

   double myMovingAverageArray100[],myMovingAverageArray200[];

// define the properties of the Moving Average1
   int movingAverageDefinition1=iMA(_Symbol,_Period,5,0,MODE_EMA,PRICE_CLOSE);

// define the properties of the Moving Average2
   int movingAverageDefinition2=iMA(_Symbol,_Period,21,0,MODE_SMA,PRICE_CLOSE);

// define the properties of the Moving Average3
   int movingAverageDefinition3=iMA(_Symbol,_Period,100,0,MODE_EMA,PRICE_CLOSE);

// define the properties of the Moving Average4
   int movingAverageDefinition4=iMA(_Symbol,_Period,200,0,MODE_EMA,PRICE_CLOSE);

// sort the price array1 from the current candle downwards
   ArraySetAsSeries(myMovingAverageArray5,true);

// sort the price array2 from the current candle downwards
   ArraySetAsSeries(myMovingAverageArray21,true);

// sort the price array3 from the current candle downwards
   ArraySetAsSeries(myMovingAverageArray100,true);

// sort the price array4 from the current candle downwards
   ArraySetAsSeries(myMovingAverageArray200,true);

// Defined MA1, one line,current candle,3 candles, store result 
   CopyBuffer(movingAverageDefinition1,0,0,3,myMovingAverageArray5);

// Defined MA2, one line,current candle,3 candles, store result 
   CopyBuffer(movingAverageDefinition2,0,0,3,myMovingAverageArray21);

// Defined MA3, one line,current candle,3 candles, store result 
   CopyBuffer(movingAverageDefinition3,0,0,3,myMovingAverageArray100);

// Defined MA4, one line,current candle,3 candles, store result 
   CopyBuffer(movingAverageDefinition4,0,0,3,myMovingAverageArray200);

   if(TotalOrdersCount()==0)
     {

      if(// Check if the 5 candle EA is above the 21 candle EA  -->buy
         (myMovingAverageArray5[0]>myMovingAverageArray21[0])
         && (myMovingAverageArray5[1]<myMovingAverageArray21[1])
         && (myMovingAverageArray21[1]>myMovingAverageArray100[1])
         && (myMovingAverageArray100[1]>myMovingAverageArray200[1])
         )
        {

         if(StopLoss>0)SL=NormalizeDouble(Bid-StopLoss*pm*_Point,_Digits);
         else SL=0;
         if(TakeProfit>0)TP=NormalizeDouble(Ask+TakeProfit*pm*_Point,_Digits);
         else TP=0;
         trade.Buy(Lots,NULL,Ask,SL,TP,NULL);
         return;

        }

      if(// Check if the 5 candle EA is bellow the 21 candle EA -->sell          
         (myMovingAverageArray5[0]<myMovingAverageArray21[0])
         && (myMovingAverageArray5[1]>myMovingAverageArray21[1])
         && (myMovingAverageArray21[1]<myMovingAverageArray100[1])
         && (myMovingAverageArray100[1]<myMovingAverageArray200[1])
         )
        {

         if(StopLoss>0)SL=NormalizeDouble(Ask+StopLoss*pm*_Point,_Digits);
         else SL=0;
         if(TakeProfit>0)TP=NormalizeDouble(Bid-TakeProfit*pm*_Point,_Digits);
         else TP=0;
         trade.Sell(Lots,NULL,Bid,SL,TP,NULL);
         return;

        }
     }

   
  }
//+------------------------------------------------------------------+
int TotalOrdersCount()
  {
   int result=0;
   for(int i=PositionsTotal()-1; i>=0; --i)
     {
      string symbol=PositionGetSymbol(i);
      ulong magic=PositionGetInteger(POSITION_MAGIC);
      if(symbol==_Symbol && magic==MagicNumber)
        {
         result++;

        }
     }
   return (result);
  }
//+------------------------------------------------------------------+
void CloseAll()
  {
   int result=0;
   for(int i=PositionsTotal()-1; i>=0; --i)
     {
      ulong ticket=PositionGetInteger(POSITION_TICKET);
      string symbol=PositionGetSymbol(i);
      ulong magic=PositionGetInteger(POSITION_MAGIC);
      if(symbol==_Symbol && magic==MagicNumber)
        {
         trade.PositionClose(ticket);

        }

     }
   return;
  }
//------------------------------------------------------------------------+
void Reverse() 
  {
   double lots;
   ulong ticket;
   string symbol;
   ulong magic;
   for(int i=PositionsTotal()-1; i>=0; --i) 
     {
      symbol=PositionGetSymbol(i);
      magic=PositionGetInteger(POSITION_MAGIC);
      if(symbol==_Symbol && magic==MagicNumber)
        {

         ticket=PositionGetInteger(POSITION_TICKET);

         ENUM_POSITION_TYPE type=(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);

         if(type==POSITION_TYPE_BUY)
           {
            lots=2*PositionGetDouble(POSITION_VOLUME);
            //trade.PositionClose(ticket);
            
            trade.Sell(lots,NULL,Bid,0,0,NULL);
           }
         if(type==POSITION_TYPE_SELL)
           {
            lots=2*PositionGetDouble(POSITION_VOLUME);
            //trade.PositionClose(ticket);
            trade.Buy(lots,NULL,Ask,0,0,NULL);
           }
        }
     }
  }
//+------------------------------------------------------------------+
double ProfitSymbol()
  {
   double profit=0;
   string symbol;
   double order_profit;
   ulong magic;
   for(int i=PositionsTotal()-1; i>=0; --i)
     {
      symbol=PositionGetSymbol(i);
      magic=PositionGetInteger(POSITION_MAGIC);
      order_profit = PositionGetDouble(POSITION_PROFIT);
      if(symbol==_Symbol && magic==MagicNumber)
        {
         profit+=order_profit;

        }
     }
   return (profit);
  }
  
  
//------------------------------------------------+
void Trailing(){
for(int i=PositionsTotal()-1; i>=0; --i)
     {
      string symbol=PositionGetSymbol(i);
      ulong magic=PositionGetInteger(POSITION_MAGIC);
      if(symbol==_Symbol && magic==MagicNumber)
        {

         ulong ticket=PositionGetInteger(POSITION_TICKET);
         double stoploss=PositionGetDouble(POSITION_SL);
         double takeprofit= PositionGetDouble(POSITION_TP);
         double openprice = PositionGetDouble(POSITION_PRICE_OPEN);
         ENUM_POSITION_TYPE type=(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);

         if(type==POSITION_TYPE_BUY)
           {

            if(TrailingStop>0)
              {
               if(Bid-openprice>NormalizeDouble(pm*_Point*TrailingStop,_Digits))
                 {
                  if(stoploss<NormalizeDouble(Bid-pm*_Point*TrailingStop,_Digits))
                    {

                     trade.PositionModify(ticket,NormalizeDouble(Bid-TrailingStop*pm*_Point,_Digits),takeprofit);

                     return;

                    }
                 }
              }
           }

         else
           {
            if(TrailingStop>0)
              {
               if((openprice-Ask)>NormalizeDouble(pm*_Point*TrailingStop,_Digits))
                 {
                  if(stoploss>NormalizeDouble(Ask+pm*_Point*TrailingStop,_Digits) || stoploss==0)
                    {
                     trade.PositionModify(ticket,NormalizeDouble(Ask+pm*_Point*TrailingStop,_Digits),takeprofit);
                     return;
                    }
                 }
              }

           }

        }
     }
     return;
}   